﻿using System;
using System.Collections.Generic;
using System.Linq;

using MonoTouch.Foundation;
using MonoTouch.UIKit;

using Microsoft.WindowsAzure.MobileServices;

namespace LongDriveiOS
{
    // The UIApplicationDelegate for the application. This class is responsible for launching the 
    // User Interface of the application, as well as listening (and optionally responding) to 
    // application events from iOS.
    [Register("AppDelegate")]
    public partial class AppDelegate : UIApplicationDelegate
    {
        public MobileServiceClient client;
        public MobileServiceUser user;
        UIWindow window;
        LoginController login;
        UITabBarController tbc;
        public string DeviceToken { get; set; }

        public override bool FinishedLaunching(UIApplication app, NSDictionary options)
        {
            UIRemoteNotificationType notificationTypes = UIRemoteNotificationType.Alert |
                UIRemoteNotificationType.Badge | UIRemoteNotificationType.Sound;
            UIApplication.SharedApplication.RegisterForRemoteNotificationTypes(notificationTypes); 

            client = new MobileServiceClient(Support.AppConstants.ApplicationURL, Support.AppConstants.ApplicationKey);
            window = new UIWindow(UIScreen.MainScreen.Bounds);
            login = new LoginController();
            window.RootViewController = new UINavigationController(login);
            window.MakeKeyAndVisible();
            CurrentPlatform.Init();
            return true;
        }

        internal void ChangeLoginControllerToTabBarController()
        {
            tbc = new UITabBarController();
            var vc1 = new CurrentStandingsController();
            var vc2 = new UploadViewController();
            
            UINavigationController uinc1 = new UINavigationController(vc1);
            UINavigationController uinc2 = new UINavigationController(vc2);
            
            tbc.ViewControllers = new UIViewController[] {
				uinc1,
				uinc2,
			};
            uinc1.Title = "Dashboard";
            uinc2.Title = "Your Drive";
            tbc.TabBar.Items[0].Image = UIImage.FromFile("./images/dashboard.png");
            tbc.TabBar.Items[1].Image = UIImage.FromFile("./images/drive.png");

            window.RootViewController = tbc;
        }
        public override void RegisteredForRemoteNotifications(UIApplication application, NSData deviceToken)
        {
            string trimmedDeviceToken = deviceToken.Description;
            if (!string.IsNullOrWhiteSpace(trimmedDeviceToken))
            {
                trimmedDeviceToken = trimmedDeviceToken.Trim('<');
                trimmedDeviceToken = trimmedDeviceToken.Trim('>');
            }
            DeviceToken = trimmedDeviceToken;
        }

        public override void ReceivedRemoteNotification(UIApplication application, NSDictionary userInfo)
        {
            System.Diagnostics.Debug.WriteLine(userInfo.ToString());
            NSObject inAppMessage;

            bool success = userInfo.TryGetValue(new NSString("inAppMessage"), out inAppMessage);

            if (success)
            {
                var alert = new UIAlertView("Got push notification", inAppMessage.ToString(), null, "OK", null);
                alert.Show();
            }
        }
    }
}