using System;
using System.Drawing;

using MonoTouch.CoreFoundation;
using MonoTouch.UIKit;
using MonoTouch.Foundation;

using Microsoft.WindowsAzure.MobileServices;

namespace LongDriveiOS
{
    public class LoginController : UIViewController
    {
        AppDelegate app;
        UIButton btnFacebookLogin;
        UIButton btnTwitterLogin;
        public LoginController()
        {
        }

        public override void DidReceiveMemoryWarning()
        {
            // Releases the view if it doesn't have a superview.
            base.DidReceiveMemoryWarning();

            // Release any cached data, images, etc that aren't in use.
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            this.View.BackgroundColor = UIColor.White;
            app = (AppDelegate)UIApplication.SharedApplication.Delegate;
            btnFacebookLogin = UIButton.FromType(UIButtonType.System);
            btnFacebookLogin.Frame = new RectangleF(10, 100f,
                View.Frame.Width - 20, 44f);
            btnFacebookLogin.SetTitle("Login w/ Facebook", UIControlState.Normal);
            btnFacebookLogin.TouchUpInside += btnFacebookLogin_TouchUpInside;
            View.Add(btnFacebookLogin);
            btnTwitterLogin = UIButton.FromType(UIButtonType.System);
            btnTwitterLogin.Frame = new RectangleF(10, btnFacebookLogin.Frame.Bottom + 22f,
                View.Frame.Width - 20, 44f);
            btnTwitterLogin.SetTitle("Login w/ Twitter", UIControlState.Normal);
            btnTwitterLogin.TouchUpInside += btnTwitterLogin_TouchUpInside;
            View.Add(btnTwitterLogin);
        }

        async void btnTwitterLogin_TouchUpInside(object sender, EventArgs e)
        {
            try
            {
                var loginUser = await app.client.LoginAsync(this,
                    MobileServiceAuthenticationProvider.Twitter);
                app.client.CurrentUser = loginUser;
                SuccessfulLogin();
            }
            catch (System.Exception sysexc)
            {
                Console.WriteLine(sysexc.Message);
            }
        }
        async void btnFacebookLogin_TouchUpInside(object sender, EventArgs e)
        {
            try
            {
                app.client.CurrentUser = await app.client.LoginAsync(this, 
                    MobileServiceAuthenticationProvider.Facebook);
                SuccessfulLogin();
            }
            catch (System.Exception sysexc)
            {
                Console.WriteLine(sysexc.Message);
            }
        }
        void SuccessfulLogin()
        {
            if (app.client.CurrentUser.UserId != String.Empty)
            {
                app.ChangeLoginControllerToTabBarController();
            }
        }
    }
}