using System;
using System.Drawing;
using System.Threading.Tasks;

using MonoTouch.CoreFoundation;
using MonoTouch.UIKit;
using MonoTouch.Foundation;
using MonoTouch.CoreLocation;

using Xamarin.Geolocation;

using Support;

namespace LongDriveiOS
{
    public class UploadViewController : UIViewController
    {
        Xamarin.Geolocation.Position first, second;
        Xamarin.Geolocation.Geolocator geo;
        AppDelegate app;
        UIButton btnFirstPoint, btnSecondPoint;
        DateTime startingTime, endingTime;
        public UploadViewController()
        {
        }

        public override void DidReceiveMemoryWarning()
        {
            // Releases the view if it doesn't have a superview.
            base.DidReceiveMemoryWarning();

            // Release any cached data, images, etc that aren't in use.
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            this.View.BackgroundColor = UIColor.White;
            btnFirstPoint = UIButton.FromType(UIButtonType.System);
            btnFirstPoint.Frame = new RectangleF(10, 100, this.View.Bounds.Width - 20, 44);
            btnFirstPoint.SetTitle("Your Drive", UIControlState.Normal);
            btnFirstPoint.TouchUpInside += btnFirstPoint_TouchUpInside;
            this.View.Add(btnFirstPoint);

            btnSecondPoint = UIButton.FromType(UIButtonType.System);
            btnSecondPoint.Frame = new RectangleF(10, btnFirstPoint.Frame.Bottom + 50, 
                this.View.Bounds.Width - 20, 44);
            btnSecondPoint.SetTitle("Your Second Shot", UIControlState.Normal);
            btnSecondPoint.TouchUpInside += btnSecondPoint_TouchUpInside;
            this.View.Add(btnSecondPoint);
            app = (AppDelegate)UIApplication.SharedApplication.Delegate;
        }

        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
            btnFirstPoint.Enabled = true;
            btnSecondPoint.Enabled = false;
            geo = new Geolocator() { DesiredAccuracy = 1f };
        }

        public override void ViewDidDisappear(bool animated)
        {
            base.ViewDidDisappear(animated);
            geo = null;
        }
        async void btnSecondPoint_TouchUpInside(object sender, EventArgs e)
        {
            try
            {
                btnSecondPoint.Enabled = false;
                endingTime = DateTime.UtcNow;
                // var secondShot = new Geolocator() { DesiredAccuracy = 1f };
                await geo.GetPositionAsync(timeout: 30000).ContinueWith(t =>
                {
                    second = t.Result;
                }, TaskScheduler.FromCurrentSynchronizationContext());
                PostDrive();
                var uiav = new UIAlertView("Drive", 
                    "Your drive has been recorded", 
                    null, "Ok", null);
                uiav.Show();
                btnFirstPoint.Enabled = true;
                btnSecondPoint.Enabled = false;
            }
            catch(System.Exception sysExc)
            {
                Console.WriteLine(sysExc.Message);
                btnSecondPoint.Enabled = true;
                // log and/or do something else;
            }
        }
        async void btnFirstPoint_TouchUpInside(object sender, EventArgs e)
        {
            try
            {
                btnFirstPoint.Enabled = false;
                startingTime = DateTime.UtcNow;
                // var driveLocation = new Geolocator() { DesiredAccuracy = 1f };
                
                await geo.GetPositionAsync(timeout: 30000).ContinueWith(t =>
                {
                    first = t.Result;
                    btnSecondPoint.Enabled = true;

                }, TaskScheduler.FromCurrentSynchronizationContext());

            }
            catch (System.Exception sysExc)
            {
                Console.WriteLine(sysExc.Message);
                btnFirstPoint.Enabled = true;
                // log and/or do something else;
            }
        }


        async void PostDrive()
        {
            Drive d = new Drive();
            d.StartingLat = first.Latitude;
            d.StartingLon = first.Longitude;
            d.EndingLat = second.Latitude;
            d.EndingLon = second.Longitude;
            d.StartingTime = startingTime;
            d.EndingTime = endingTime;
            d.deviceType = (int)Support.AppConstants.DeviceType.AppleIOS;
            d.DeviceToken = app.DeviceToken;

            try
            {
                await app.client.GetTable<Support.Drive>().InsertAsync(d);
            }
            catch (System.Exception exc)
            {
                Console.WriteLine(exc.Message);
            }
        }
    }
}